!> \file lakes-prescribed_mod-0.1.f90
!! Module pour determiner les lacs proglaciaires 
!<

!> \namespace  lakes_prescribed_mod
!! Calcule le beta a partir de vitesses de bilan
!! @note Les lacs sont imposes au cours du temps
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!<

module lakes_prescribed_mod


! les lacs proglaciaires sont imposes au cours du temps

USE module3D_phy
implicit none

integer,parameter         :: nb_lakes=5                 !< nombre de lacs maxi
integer                   :: i_lake                     !< index des lacs
integer, dimension(nx,ny) :: lake                       !< les lacs sont tagges
real,dimension(5)         :: level_lakes                !< les niveaux des lacs
character (len=20)        :: fil_lakes                  !< nom du fichier lacs

contains                   	

subroutine input_lakes

namelist/lakes/fil_lakes,level_lakes

! lecture par namelist 
!---------------------

! formats pour les ecritures dans 42
428 format(A)

rewind(num_param)        ! pour revenir au debut du fichier param_list.dat
read(num_param,lakes)

write(num_rep_42,428)'!___________________________________________________________' 
write(num_rep_42,428) '&lakes                            ! module  lakes_prescribed_mod'
write(num_rep_42,'(A,A)')             'fil_lakes   =', fil_lakes
write(num_rep_42,'(A,5(f0.1,","))')  'level_lakes =', level_lakes
write(num_rep_42,*)'/'                      
write(num_rep_42,428) '! lac 2 -> Komi, lac 3-> Siberian, on ignore qui est le lac 1'
write(num_rep_42,428) '! 0 pas de lac . Faire attention au nombre de lacs et nb_lakes'
write(num_rep_42,*)

end subroutine input_lakes

subroutine lake_to_slv

! inclut les lacs dans le tableau slv des niveaux de flottaison

slv(:,:)=sealevel

! VOIR COMMENT ACTIVER-DESACTIVER LES LACS EN FONCTION DU TEMPS

do j=1,ny
   do i=1,nx     
      do i_lake=1,nb_lakes
         if (lake(i,j).eq.i_lake) then 
            slv(i,j)=max(level_lakes(i_lake),Bsoc(i,j))
         end if
      end do
   end do
end do

end subroutine lake_to_slv

end module lakes_prescribed_mod
