!   tracer parameters and arrays
!   try to minimize use of allocatable arrays

module tracer_vars
  
  use module3d_phy
  
  implicit none
  save
  
  integer, dimension(nx*ny) :: ix, jx
  
  !! The integer array indx_tr(i,j) yields an index value which is the
  !! ij subscript of the tracer archive array archive_tr(:,:,:)
  
  integer :: nij                 ! number of (i,j)->ij mappings
  
  integer, parameter :: unit_tr_dat=572
  integer, parameter :: unit_tr_out=573
  integer, parameter :: unit_tr_dep=574
  
  integer, parameter :: maxspectimes=31
  
  integer :: delttrout
  integer :: nspectimes
  real :: time_max_accu
  
  integer, dimension(maxspectimes) :: trout
  real, dimension(nx) :: xgrid
  real, dimension(ny) :: ygrid
  
  real , dimension(nx*ny) :: TS_save
  real , dimension(nx*ny) :: hi_save
  real , dimension(nx*ny) :: bi_save

      !! Traced scalars (xd, yd, td) for sheet
      !! (deposition point and deposition time) for present and previous times

! dep, tableau (grille 'o') "origine de la glace" au temp time
  real , dimension(nz,nx-2,ny-2) :: xdep
  real , dimension(nz,nx-2,ny-2) :: ydep
  real , dimension(nz,nx-2,ny-2) :: tdep

! dep, tableau (grille 'o') "origine de la glace"  a l'initialisation (a confirmer)
  real , dimension(nz,nx-2,ny-2) :: xdepk    ! 
  real , dimension(nz,nx-2,ny-2) :: ydepk    !
  real , dimension(nz,nx-2,ny-2) :: tdepk    !

! dep, tableau (grille 'o') "origine de la glace" au temp time, dimension pour outputs
  real , dimension(nx,ny,nz) :: xdep_out
  real , dimension(nx,ny,nz) :: ydep_out
  real , dimension(nx,ny,nz) :: tdep_out

  real , dimension(nz) :: lnzeta

  character (LEN=60) :: file_tr_dat, file_tr_out, file_tr_dep
  
  real , dimension(nx,ny,nz) :: uxsave
  real , dimension(nx,ny,nz) :: uysave
  real , dimension(nx,ny,nz) :: uzrsave
  
  real , allocatable, dimension(:) :: accucumul

  real, dimension(nx-2,ny-2) :: freezeon


end module tracer_vars

