!> \file write_datfile.f90
!! Fiel to write a ZBL file (strating from bottom left)
!<

!> SUBROUTINE: write_datfile2
!! ecriture of a ZBL file (starting from bottom left)
!! @param  nxx                dimension along x
!! @param  nyy                dimension along y
!! @param  numcol             column number
!! @param  filename           
!! @return Tab                the value of Tab(nxx,nyy): Warning it is a real

subroutine write_datfile2(nxx,nyy,Tab1,Tab2,filename)

implicit none
integer,intent(in)  :: nxx                    !< dimension along x
integer,intent(in)  :: nyy                    !< dimension along y
character(len=80),intent(in) :: filename      !< name of the file
real,dimension(nxx,nyy),intent(in) :: Tab1   !< the array that is writen
real,dimension(nxx,nyy),intent(in) :: Tab2   !< the array that is writen


integer  :: i,j                ! working integers
integer  :: lx,ly              ! nxx, nyy read in the file


open(22,file=trim(filename))
write(22,*) nxx,nyy  !, xmin,xmax,ymin,ymax ?
do j=1,nyy
   do i=1,nxx
      write(22,*) Tab1(i,j),Tab2(i,j)
   end do
end do


close(22)
return
end subroutine write_datfile2
!> SUBROUTINE: write_datfile3
!! ecriture of a ZBL file (starting from bottom left)
!! @param  nxx                dimension along x
!! @param  nyy                dimension along y
!! @param  numcol             column number
!! @param  filename           
!! @return Tab   
subroutine write_datfile3(nxx,nyy,Tab1,Tab2,Tab3,filename)

implicit none
integer,intent(in)  :: nxx                    !< dimension along x
integer,intent(in)  :: nyy                    !< dimension along y
character(len=80),intent(in) :: filename      !< name of the file
real,dimension(nxx,nyy),intent(in) :: Tab1   !< the array that is writen
real,dimension(nxx,nyy),intent(in) :: Tab2   !< the array that is writen
real,dimension(nxx,nyy),intent(in) :: Tab3   !< the array that is writen

integer  :: i,j                ! working integers
integer  :: lx,ly              ! nxx, nyy read in the file


open(22,file=trim(filename))
write(22,*) nxx,nyy  !, xmin,xmax,ymin,ymax ?
do j=1,nyy
   do i=1,nxx
      write(22,*) Tab1(i,j),Tab2(i,j),Tab3(i,j)
   end do
end do


close(22)
return
end subroutine write_datfile3
